#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

long long gcd(long long a, long long b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

vector <long long> divisors(long long n) {
    vector <long long> ans;

    for (long long i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            ans.push_back(i);
            if (n != i * i) ans.push_back(n / i);
        }
    }

    sort(ans.begin(), ans.end());
    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long n, m, h, v, ans = 0;
    cin >> n >> m >> h >> v;

    vector <long long> horizontal, vertical;

    for (int i = 0; i < h; i++) {
        long long val;
        cin >> val;

        horizontal.push_back(--val);
    }

    horizontal.push_back(0);
    horizontal.push_back(n);
    sort(horizontal.begin(), horizontal.end());

    for (int i = 0; i < v; i++) {
        long long val;
        cin >> val;

        vertical.push_back(--val);
    }

    vertical.push_back(0);
    vertical.push_back(m);
    sort(vertical.begin(), vertical.end());

    for (int i = 1; i < horizontal.size(); i++) {
        ans = gcd(ans, horizontal[i] - horizontal[i - 1]);
    }

    for (int i = 1; i < vertical.size(); i++) {
        ans = gcd(ans, vertical[i] - vertical[i - 1]);
    }

    vector <long long> numbers = divisors(ans);
    cout << numbers.size() << endl;
    cout << numbers.front();

    for (int i = 1; i < numbers.size(); i++) {
        cout << ' ' << numbers[i];
    }

    cout << endl;

    return 0;

}
